# this probably needs to be removed from jam-web source, and moved only to chef

rails_root  = ENV['RAILS_ROOT'] || '.'
rails_env   = ENV['RAILS_ENV']  || "development"
num_workers = ENV['NUM_WORKERS'] || 2
queues = ENV['QUEUE'] || '*'

num_workers.times do |num|
  God.watch do |w|
    w.dir      = "#{rails_root}"
    w.name     = "resque-#{num}"
    w.group    = 'resque'
    w.interval = 30.seconds
    w.env      = {"QUEUE"=>queues, "RAILS_ENV"=>rails_env}
    w.start    = "/usr/local/bin/bundle exec rake environment resque:work"

    #w.uid = 'jam-resque'
    #w.gid = 'jam-resque'

    # restart if memory gets too high
    w.transition(:up, :restart) do |on|
      on.condition(:memory_usage) do |c|
        c.above = 350.megabytes
        c.times = 2
      end
    end

    # determine the state on startup
    w.transition(:init, { true => :up, false => :start }) do |on|
      on.condition(:process_running) do |c|
        c.running = true
      end
    end

    # determine when process has finished starting
    w.transition([:start, :restart], :up) do |on|
      on.condition(:process_running) do |c|
        c.running = true
        c.interval = 5.seconds
      end

      # failsafe
      on.condition(:tries) do |c|
        c.times = 5
        c.transition = :start
        c.interval = 5.seconds
      end
    end

    # start if process is not running
    w.transition(:up, :start) do |on|
      on.condition(:process_running) do |c|
        c.running = false
      end
    end
  end
end
